'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var createCollection = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repository, name) {
        var client, metaCollection, collection;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        client = repository.client, metaCollection = repository.metaCollection;
                        _context.next = 3;
                        return (0, _redisApi.exists)(client, name);

                    case 3:
                        if (!_context.sent) {
                            _context.next = 5;
                            break;
                        }

                        throw new Error('Collection ' + name + ' is exist');

                    case 5:
                        _context.next = 7;
                        return collectionExists(repository, name);

                    case 7:
                        if (!_context.sent) {
                            _context.next = 9;
                            break;
                        }

                        throw new Error('Collection ' + name + ' had already been created in current database, ' + 'but not with resolve read model adapter and has no required meta information');

                    case 9:
                        _context.next = 11;
                        return metaCollection.create(name);

                    case 11:
                        _context.next = 13;
                        return (0, _collection.nativeCollection)(repository, name);

                    case 13:
                        collection = _context.sent;
                        _context.next = 16;
                        return collection.ensureIndex({ fieldName: '_id', fieldType: 'number' });

                    case 16:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));

    return function createCollection(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

var dropCollection = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3, name) {
        var client = _ref3.client,
            metaCollection = _ref3.metaCollection;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return (0, _redisApi.del)(client, name);

                    case 2:
                        _context2.next = 4;
                        return metaCollection.del(name);

                    case 4:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function dropCollection(_x3, _x4) {
        return _ref2.apply(this, arguments);
    };
}();

var collectionExists = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref5, name) {
        var metaCollection = _ref5.metaCollection;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return metaCollection.exists(name);

                    case 2:
                        return _context3.abrupt('return', _context3.sent);

                    case 3:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function collectionExists(_x5, _x6) {
        return _ref4.apply(this, arguments);
    };
}();

var listCollections = function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(repository) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return repository.metaCollection.listCollections(repository);

                    case 2:
                        return _context4.abrupt('return', _context4.sent);

                    case 3:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function listCollections(_x7) {
        return _ref6.apply(this, arguments);
    };
}();

var _redisApi = require('./redisApi');

var _collection = require('./collection');

var _metaCollection = require('../src/metaCollection');

var _metaCollection2 = _interopRequireDefault(_metaCollection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var adapter = function adapter(repository) {
    repository.metaCollection = (0, _metaCollection2.default)(repository);

    return Object.freeze({
        createCollection: createCollection.bind(null, repository),
        dropCollection: dropCollection.bind(null, repository),
        collection: _collection.nativeCollection.bind(null, repository),
        exists: collectionExists.bind(null, repository),
        listCollections: listCollections.bind(null, repository)
    });
};

exports.default = adapter;
module.exports = exports['default'];