'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var initProjection = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repository) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _context.next = 2;
                        return repository.connectionPromise;

                    case 2:
                        if (!(repository.lastTimestamp !== 0)) {
                            _context.next = 4;
                            break;
                        }

                        return _context.abrupt('return');

                    case 4:
                        repository.lastTimestamp = 1;

                        _context.prev = 5;
                        _context.next = 8;
                        return repository.initHandler(repository.writeInterface);

                    case 8:
                        _context.next = 13;
                        break;

                    case 10:
                        _context.prev = 10;
                        _context.t0 = _context['catch'](5);

                        repository.internalError = _context.t0;

                    case 13:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[5, 10]]);
    }));

    return function initProjection(_x) {
        return _ref.apply(this, arguments);
    };
}();

var getReadOnlyCollectionInterface = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(repository, collectionName) {
        var nativeAdapter, collection, inf, exceptWriteFunction;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        nativeAdapter = repository.nativeAdapter;
                        _context2.next = 3;
                        return nativeAdapter.collection(collectionName);

                    case 3:
                        collection = _context2.sent;
                        inf = {
                            findOne: collection.findOne,
                            find: collection.find,
                            count: collection.count
                        };

                        exceptWriteFunction = function exceptWriteFunction(funcName, collectionName) {
                            throw new Error('The ' + collectionName + ' collection\u2019s ' + funcName + ' method is not allowed on the read side');
                        };

                        return _context2.abrupt('return', Object.freeze(['insert', 'update', 'remove', 'ensureIndex', 'removeIndex'].reduce(function (acc, funcName) {
                            acc[funcName] = exceptWriteFunction.bind(null, funcName, collectionName);
                            return acc;
                        }, inf)));

                    case 7:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function getReadOnlyCollectionInterface(_x2, _x3) {
        return _ref2.apply(this, arguments);
    };
}();

var getCollectionInterface = function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(repository, isWriteable, collectionName) {
        var nativeAdapter;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return repository.connectionPromise;

                    case 2:
                        nativeAdapter = repository.nativeAdapter;
                        _context3.next = 5;
                        return nativeAdapter.exists(collectionName);

                    case 5:
                        if (_context3.sent) {
                            _context3.next = 10;
                            break;
                        }

                        if (isWriteable) {
                            _context3.next = 8;
                            break;
                        }

                        throw new Error('Collection ' + collectionName + ' does not exists');

                    case 8:
                        _context3.next = 10;
                        return nativeAdapter.createCollection(collectionName);

                    case 10:
                        if (!isWriteable) {
                            _context3.next = 12;
                            break;
                        }

                        return _context3.abrupt('return', (0, _collection.writeCollectionInterface)(repository, collectionName));

                    case 12:
                        return _context3.abrupt('return', getReadOnlyCollectionInterface(repository, collectionName));

                    case 13:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));

    return function getCollectionInterface(_x4, _x5, _x6) {
        return _ref3.apply(this, arguments);
    };
}();

var listCollections = function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(repository) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return repository.connectionPromise;

                    case 2:
                        _context4.next = 4;
                        return repository.nativeAdapter.listCollections();

                    case 4:
                        return _context4.abrupt('return', _context4.sent);

                    case 5:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function listCollections(_x7) {
        return _ref4.apply(this, arguments);
    };
}();

var synchronizeDatabase = function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(repository, client) {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.t0 = Math;
                        _context5.t1 = repository.lastTimestamp;
                        _context5.next = 4;
                        return repository.metaCollection.getMaxLastTimestamp();

                    case 4:
                        _context5.t2 = _context5.sent;
                        repository.lastTimestamp = _context5.t0.max.call(_context5.t0, _context5.t1, _context5.t2);

                    case 6:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this);
    }));

    return function synchronizeDatabase(_x8, _x9) {
        return _ref5.apply(this, arguments);
    };
}();

exports.default = init;

var _adapter = require('./adapter');

var _adapter2 = _interopRequireDefault(_adapter);

var _metaCollection = require('./metaCollection');

var _metaCollection2 = _interopRequireDefault(_metaCollection);

var _collection = require('./collection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function getStoreInterface(repository, isWriteable) {
    var nativeAdapter = repository.nativeAdapter;

    return Object.freeze({
        collection: getCollectionInterface.bind(null, repository, isWriteable),
        listCollections: listCollections.bind(null, repository)
    });
}

function init(repository) {
    var _this = this;

    if (repository.interfaceMap) {
        throw new Error('The read model storage is already initialized');
    }
    repository.lastTimestamp = 0;

    if (typeof repository.initHandler !== 'function') {
        repository.initHandler = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
                while (1) {
                    switch (_context6.prev = _context6.next) {
                        case 0:
                        case 'end':
                            return _context6.stop();
                    }
                }
            }, _callee6, _this);
        }));
    }

    repository.connectionPromise = repository.connectDatabase().then(function (client) {
        return repository.client = client;
    }).then(synchronizeDatabase.bind(null, repository));

    repository.interfaceMap = new Map();
    repository.internalError = null;

    repository.nativeAdapter = (0, _adapter2.default)(repository);

    repository.readInterface = getStoreInterface(repository, false);
    repository.writeInterface = getStoreInterface(repository, true);

    repository.initDonePromise = initProjection(repository);

    return {
        getLastAppliedTimestamp: function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                _context7.next = 2;
                                return repository.connectionPromise;

                            case 2:
                                return _context7.abrupt('return', repository.lastTimestamp);

                            case 3:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, _this);
            }));

            return function getLastAppliedTimestamp() {
                return _ref7.apply(this, arguments);
            };
        }(),
        getReadable: function () {
            var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
                return regeneratorRuntime.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                _context8.next = 2;
                                return repository.initDonePromise;

                            case 2:
                                return _context8.abrupt('return', repository.readInterface);

                            case 3:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, _this);
            }));

            return function getReadable() {
                return _ref8.apply(this, arguments);
            };
        }(),
        getError: function () {
            var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
                return regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                _context9.next = 2;
                                return repository.initDonePromise;

                            case 2:
                                return _context9.abrupt('return', repository.internalError);

                            case 3:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, _this);
            }));

            return function getError() {
                return _ref9.apply(this, arguments);
            };
        }()
    };
}
module.exports = exports['default'];