'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var disposeDatabase = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2, client) {
        var _this = this;

        var metaCollectionName = _ref2.metaCollectionName,
            autoincMetaCollectionName = _ref2.autoincMetaCollectionName,
            lastTimestampCollectionName = _ref2.lastTimestampCollectionName;
        var tempRepository, adapter, collectionNames, promises;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        tempRepository = {
                            metaCollectionName: metaCollectionName,
                            autoincMetaCollectionName: autoincMetaCollectionName,
                            lastTimestampCollectionName: lastTimestampCollectionName,
                            client: client
                        };
                        adapter = (0, _adapter2.default)(tempRepository);
                        _context2.next = 4;
                        return adapter.listCollections();

                    case 4:
                        collectionNames = _context2.sent;
                        promises = collectionNames.map(function () {
                            var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(collectionName) {
                                return regeneratorRuntime.wrap(function _callee$(_context) {
                                    while (1) {
                                        switch (_context.prev = _context.next) {
                                            case 0:
                                                _context.next = 2;
                                                return adapter.dropCollection(collectionName);

                                            case 2:
                                            case 'end':
                                                return _context.stop();
                                        }
                                    }
                                }, _callee, _this);
                            }));

                            return function (_x3) {
                                return _ref3.apply(this, arguments);
                            };
                        }());
                        _context2.next = 8;
                        return Promise.all(promises);

                    case 8:
                        _context2.t0 = Promise;
                        _context2.next = 11;
                        return (0, _redisApi.del)(client, metaCollectionName);

                    case 11:
                        _context2.t1 = _context2.sent;
                        _context2.next = 14;
                        return (0, _redisApi.del)(client, autoincMetaCollectionName);

                    case 14:
                        _context2.t2 = _context2.sent;
                        _context2.next = 17;
                        return (0, _redisApi.del)(client, lastTimestampCollectionName);

                    case 17:
                        _context2.t3 = _context2.sent;
                        _context2.t4 = [_context2.t1, _context2.t2, _context2.t3];
                        _context2.next = 21;
                        return _context2.t0.all.call(_context2.t0, _context2.t4);

                    case 21:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));

    return function disposeDatabase(_x, _x2) {
        return _ref.apply(this, arguments);
    };
}();

exports.default = reset;

require('regenerator-runtime/runtime');

var _redisApi = require('./redisApi');

var _adapter = require('./adapter');

var _adapter2 = _interopRequireDefault(_adapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function reset(repository) {
    if (repository.disposePromise) {
        return repository.disposePromise;
    }

    var client = repository.client,
        metaCollectionName = repository.metaCollectionName,
        autoincMetaCollectionName = repository.autoincMetaCollectionName,
        lastTimestampCollectionName = repository.lastTimestampCollectionName;


    var disposePromise = repository.connectionPromise.then(disposeDatabase.bind(null, {
        metaCollectionName: metaCollectionName,
        autoincMetaCollectionName: autoincMetaCollectionName,
        lastTimestampCollectionName: lastTimestampCollectionName
    }, client));

    Object.keys(repository).forEach(function (key) {
        delete repository[key];
    });

    repository.disposePromise = disposePromise;
    return disposePromise;
}
module.exports = exports['default'];